<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: EddieEndpoint Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classEddieEndpoint-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">EddieEndpoint Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:af4a195aaa66df7a9f80a1a779dd7124b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#af4a195aaa66df7a9f80a1a779dd7124b">EddieEndpoint</a> (const std::string &amp;port=&quot;5683&quot;, const std::string &amp;ip=&quot;&quot;)</td></tr>
<tr class="separator:af4a195aaa66df7a9f80a1a779dd7124b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaaa263a103754ccbc37201f76fa1500f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classCoapClient.html">CoapClient</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#aaaa263a103754ccbc37201f76fa1500f">get_client</a> ()</td></tr>
<tr class="separator:aaaa263a103754ccbc37201f76fa1500f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeaeb77ed5c8f985027b986002fa849d4"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classCoapServer.html">CoapServer</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#aeaeb77ed5c8f985027b986002fa849d4">get_server</a> ()</td></tr>
<tr class="separator:aeaeb77ed5c8f985027b986002fa849d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e5cdae0155792d7fb24d7946e733647"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#a6e5cdae0155792d7fb24d7946e733647">discover_rd</a> ()</td></tr>
<tr class="separator:a6e5cdae0155792d7fb24d7946e733647"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb40a77a9c022410d343b655b687783e"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="structLink.html">Link</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#adb40a77a9c022410d343b655b687783e">get_resources_from_rd</a> ()</td></tr>
<tr class="separator:adb40a77a9c022410d343b655b687783e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74069f4ca61eb820845e04e8e79fac86"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#a74069f4ca61eb820845e04e8e79fac86">add_resource</a> (<a class="el" href="classEddieResource.html">EddieResource</a> *resource)</td></tr>
<tr class="separator:a74069f4ca61eb820845e04e8e79fac86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46183ccdfd5ac6799be0cf67c0c2ffc0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#a46183ccdfd5ac6799be0cf67c0c2ffc0">start_server</a> (bool blocking=false)</td></tr>
<tr class="separator:a46183ccdfd5ac6799be0cf67c0c2ffc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a98c8ab9733c42b91da5d57ca3b90f046"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#a98c8ab9733c42b91da5d57ca3b90f046">stop_server</a> ()</td></tr>
<tr class="separator:a98c8ab9733c42b91da5d57ca3b90f046"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac2b7796e7b0f4d71b1eacc622ff95e2f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#ac2b7796e7b0f4d71b1eacc622ff95e2f">publish_resources</a> ()</td></tr>
<tr class="separator:ac2b7796e7b0f4d71b1eacc622ff95e2f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5f2facfeaa261ae316996d492efe0a3b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#a5f2facfeaa261ae316996d492efe0a3b">unpublish_resources</a> ()</td></tr>
<tr class="separator:a5f2facfeaa261ae316996d492efe0a3b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a297457642ef038b839a451a90b481476"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieEndpoint.html#a297457642ef038b839a451a90b481476">init_resource_dir_local</a> ()</td></tr>
<tr class="separator:a297457642ef038b839a451a90b481476"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="af4a195aaa66df7a9f80a1a779dd7124b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af4a195aaa66df7a9f80a1a779dd7124b">&#9670;&nbsp;</a></span>EddieEndpoint()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">EddieEndpoint::EddieEndpoint </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>port</em> = <code>&quot;5683&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>ip</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">explicit</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><a class="el" href="classEddieEndpoint.html">EddieEndpoint</a> constructor </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">port</td><td>Port number to assign to the node </td></tr>
    <tr><td class="paramname">ip</td><td>IP address that is assigned to the node, this IP address will be the same used to register the node's resources into the resource directory. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a74069f4ca61eb820845e04e8e79fac86"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74069f4ca61eb820845e04e8e79fac86">&#9670;&nbsp;</a></span>add_resource()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int EddieEndpoint::add_resource </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classEddieResource.html">EddieResource</a> *&#160;</td>
          <td class="paramname"><em>resource</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Add a resource into the server </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">resource</td><td>The resource containing paths, attributes and REST handlers. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 on success, a negative integer otherwise. </dd></dl>

</div>
</div>
<a id="a6e5cdae0155792d7fb24d7946e733647"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6e5cdae0155792d7fb24d7946e733647">&#9670;&nbsp;</a></span>discover_rd()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int EddieEndpoint::discover_rd </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Discover a resource directory in the network by sending a multicast CoAP request and listening for response. </p><dl class="section return"><dt>Returns</dt><dd>0 on success, -1 if no resource directory was found or an error occurred sending the request. </dd></dl>

</div>
</div>
<a id="aaaa263a103754ccbc37201f76fa1500f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaaa263a103754ccbc37201f76fa1500f">&#9670;&nbsp;</a></span>get_client()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classCoapClient.html">CoapClient</a>* EddieEndpoint::get_client </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<dl class="section return"><dt>Returns</dt><dd>The client used by the node for coap communication </dd></dl>

</div>
</div>
<a id="adb40a77a9c022410d343b655b687783e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adb40a77a9c022410d343b655b687783e">&#9670;&nbsp;</a></span>get_resources_from_rd()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="structLink.html">Link</a>&gt; EddieEndpoint::get_resources_from_rd </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get the vector of resources that are retrieved from the resource directory </p><dl class="section return"><dt>Returns</dt><dd>Vector of <a class="el" href="structLink.html">Link</a> that contains details information about the available resources in the network. </dd></dl>

</div>
</div>
<a id="aeaeb77ed5c8f985027b986002fa849d4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeaeb77ed5c8f985027b986002fa849d4">&#9670;&nbsp;</a></span>get_server()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classCoapServer.html">CoapServer</a>* EddieEndpoint::get_server </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<dl class="section return"><dt>Returns</dt><dd>The server that hosts and serves the added resources. </dd></dl>

</div>
</div>
<a id="a297457642ef038b839a451a90b481476"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a297457642ef038b839a451a90b481476">&#9670;&nbsp;</a></span>init_resource_dir_local()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void EddieEndpoint::init_resource_dir_local </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initialize a resource directory in the current node </p>

</div>
</div>
<a id="ac2b7796e7b0f4d71b1eacc622ff95e2f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac2b7796e7b0f4d71b1eacc622ff95e2f">&#9670;&nbsp;</a></span>publish_resources()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int EddieEndpoint::publish_resources </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Register the resources, previously added, in the resource directory. </p><dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error </dd></dl>

</div>
</div>
<a id="a46183ccdfd5ac6799be0cf67c0c2ffc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a46183ccdfd5ac6799be0cf67c0c2ffc0">&#9670;&nbsp;</a></span>start_server()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int EddieEndpoint::start_server </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>blocking</em> = <code>false</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Start server I/O processing loop </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">blocking</td><td>True to block until the server quits, False to run the server loop in a separate thread. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 on success, a negative integer otherwise. </dd></dl>

</div>
</div>
<a id="a98c8ab9733c42b91da5d57ca3b90f046"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a98c8ab9733c42b91da5d57ca3b90f046">&#9670;&nbsp;</a></span>stop_server()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int EddieEndpoint::stop_server </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Stop the server thread </p><dl class="section return"><dt>Returns</dt><dd>0 on success </dd></dl>

</div>
</div>
<a id="a5f2facfeaa261ae316996d492efe0a3b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5f2facfeaa261ae316996d492efe0a3b">&#9670;&nbsp;</a></span>unpublish_resources()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int EddieEndpoint::unpublish_resources </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Ask the RD node to remove all the resources registered by this endpoint </p><dl class="section return"><dt>Returns</dt><dd>0 non success, negative integer on failure </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/builds/eclipse/oniro-core/eddie/common/include/<a class="el" href="EddieEndpoint_8h_source.html">EddieEndpoint.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
